#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>
#include <grp.h>

#define WORX "/usr/local/interworx/bin/nodeworx.pex"
#define USER "iworx"

/*
 * compile with
 * cc ~iworx/private/poehler/nodeworx.c -o /usr/bin/nodeworx; chmod 711 /usr/bin/nodeworx; chmod u+s /usr/bin/nodeworx;
 */
int main( int argc, char *argv[] )
{

  struct passwd *pwd    = 0;
  struct passwd *curpwd = 0;
  char *envp[] = {NULL, NULL, NULL};

  curpwd = getpwuid( getuid() );
  envp[0] = (char *)malloc(sizeof(char) * (strlen("IWORX_UNIXUSER=") + strlen(curpwd->pw_name) + 1));
  sprintf(envp[0], "IWORX_UNIXUSER=%s", curpwd->pw_name);
  envp[1] = (char *)malloc(sizeof(char) * (strlen("PATH=/usr/bin:/bin") + 1));
  sprintf(envp[1], "PATH=%s", "/usr/bin:/bin");
  envp[2] = NULL;

  pwd = getpwnam( USER );

  setgid( pwd->pw_gid );
  initgroups( USER, pwd->pw_gid );
  setuid( pwd->pw_uid );

  return execve( WORX, argv, envp );
}
